/*
(C) 2007 Katsutoshi YAGISHITA (yagisita@spnet.ne.jp)
*/

var debug = false;

var portforio_url_param = "?sep_ind_specify_kbn=0&sort_kbn=&sort_id=&pts_kbn=0&_ControlID=WPLETpfR001Control&_PageID=WPLETpfR001Rlst10&_DataStoreID=DSWPLETpfR001Control&_ActionID=reloadPfList&getFlg=on";
var orderlist_url_param = "?_ControlID=WPLETstT013Control&_PageID=DefaultPID&_DataStoreID=DSWPLETstT013Control&getFlg=on&_ActionID=DefaultAID";
var priceboard_url_param = "?_ControlID=WPLETstT016Control&_PageID=DefaultPID&_DataStoreID=DSWPLETstT016Control&&getFlg=on&_ActionID=DefaultAID";
var accountinfo_url_param = "?_ControlID=WPLETacR011Control&_PageID=DefaultPID&_ActionID=DefaultAID&getFlg=on";

function parsePortforioWithPortforioArray(target, body)
{
	var i;
	var e;

	target.portforios = new Array();
	e = getSubstringByDivNodeFromHtml(body, "\x3c!-- |[gtHI --\x3e", "<input type=\"submit\" value=\"\" name=\"ACT_viewPf\">");
	if (e) {
		var sels = e.getElementsByTagName("SELECT");
		if (sels && sels.length == 1) {
			var ops = sels[0].getElementsByTagName("OPTION");
			if (ops) {
				for (i = 0; i < ops.length; ++i) {
					if (ops[i].value == "0" || ops[i].value == "000000000000001")
						continue;
					target.portforios[target.portforios.length] = new etrdPortforioObject(ops[i].value, getSpecifiedChildOfElement(ops[i]));
				}
			}
		}
	}

	target.indicates = new Array();
	e = getSubstringByDivNodeFromHtml(body, "\x3c!-- \` --\x3e", "<input type=\"submit\" name=\"ACT_viewPfList\" value=\"ύX\">");
	if (e) {
		var sels = e.getElementsByTagName("SELECT");
		if (sels && sels.length == 1) {
			var ops = sels[0].getElementsByTagName("OPTION");
			if (ops) {
				for (i = 0; i < ops.length; ++i) {
					if (ops[i].value == "0")
						continue;
					target.indicates[target.indicates.length] = new etrdPortforioObject(ops[i].value, getSpecifiedChildOfElement(ops[i]));
				}
			}
		}
	}

	target.accountno = null;
	i = body.search(new RegExp("Z[0-9][0-9]-[0-9][0-9][0-9][0-9][0-9][0-9][0-9]", ""));
	if (i >= 0)
		target.accountno = body.substring(i, i + 11);

	if (!parsePortforio(target, body)) {
		var estr = isEtradeError(body);
		if (!estr)
			return false;
		target.nonfatalerrors = target.nonfatalerrors + ((target.nonfatalerrors.length > 0) ? ", " : "") + estr;
	}

	target.portforioindex = -2;
	parsePortforioAndNextChain(target, null);

	return true;
}

function parsePortforioAndNextChain(target, body)
{
	target.portforioindex = target.portforioindex + 1;

	if (target.portforioindex < 0) {
		var orderlist_url = target.baseurl + orderlist_url_param;
		if (debug)
			orderlist_url = "ETGate_chuumon2.html";

		getAndParseHtml(function (body) { parseEtradeHtml(parseOrdering, target, body); }, orderlist_url, "GET", null, target.sessionheader);
		return true;
	}
	else if (target.portforios && target.portforioindex < target.portforios.length) {
		var porturl = target.baseurl + portforio_url_param + "&indicate_id=" + ((target.portforio_indicate) ? target.portforio_indicate : "000000000000001") + "&portforio_id=" + target.portforios[target.portforioindex].id;
		if (debug)
			porturl = "ETGate_port4.html";
		if (target.targetportforios) {
			var j;
			for (j = 0; j < target.targetportforios.length; ++j) {
				if (target.targetportforios[j] == target.portforios[target.portforioindex].id)
					break;
			}
			if (j >= target.targetportforios.length)
				porturl = null;
		}
		if (porturl != null) {
			getAndParseHtml(function (body) { parseEtradeHtml(parsePortforioAndNextChain, target, body); }, porturl, "GET", null, target.sessionheader);
		}
		else {
			parsePortforioAndNextChain(target, null);
		}
	}
	else {
		var accountinfo_url = target.baseurl + accountinfo_url_param;
		if (debug)
			accountinfo_url = "ETGate_accounteasy.html";

		getAndParseHtml(function (body) { parseEtradeHtml(parseAccountinfo, target, body); }, accountinfo_url, "GET", null, target.sessionheader);
		/*
		var orderlist_url = target.baseurl + orderlist_url_param;
		if (debug)
			orderlist_url = "ETGate_chuumon2.html";

		getAndParseHtml(function (body) { parseEtradeHtml(parseOrdering, target, body); }, orderlist_url, "GET", null, target.sessionheader);
		*/
	}

	if (target.portforioindex > 0 && body)
		return parsePortforio(target, body);

	return true;
}

function parsePortforio(target, body)
{
	var e = getSubstringByDivNodeFromHtml(body, "\x3c!--ו--\x3e", "\x3c!--ו--\x3e");
	if (e == null)
		return false;

	var tds;
	var i;

	var portforioTable = null;

	var index_name = -1;
	var index_currentrate = -1;
	var index_diffbyyesterday = -1;
	var index_diffbyyesterday_percent = -1;
	var index_highestrate_today = -1;
	var index_lowestrate_today = -1;
	var index_buyrate = -1;
	var index_sellrate = -1;
	var index_amount = -1;
	var index_cost = -1;
	var index_profit = -1;
	var index_profit_percent = -1;

	for (tds = e.getElementsByTagName("TD"), i = 0; portforioTable == null && i < tds.length; ++i) {
		if (getSpecifiedChildOfElement(tds[i]) == "iR[hj") {
			var trhead = getSpecifiedParentOfElement(tds[i], "TR");
			if (trhead) {
				tds = trhead.getElementsByTagName("TD");
				var j;
				for (j = 0; tds && j < tds.length; ++j) {
					var tdstr = getSpecifiedChildOfElement(tds[j]);
					if (tdstr == "iR[hj")
						index_name = j;
					else if (tdstr == "ݒl")
						index_currentrate = j;
					else if (tdstr == "O")
						index_diffbyyesterday = j;
					else if (tdstr == "Oij")
						index_diffbyyesterday_percent = j;
					else if (tdstr == "l")
						index_highestrate_today = j;
					else if (tdstr == "l")
						index_lowestrate_today = j;
					else if (tdstr == "Czl")
						index_buyrate = j;
					else if (tdstr == "Czl")
						index_sellrate = j;
					else if (tdstr == "擾P" || tdstr == "QlP")
						index_cost = j;
					else if (tdstr == "")
						index_amount = j;
					else if (tdstr == "v")
						index_profit = j;
					else if (tdstr == "vij")
						index_profit_percent = j;
					else if (tdstr == "O/") {
						var atag = getSpecifiedChildOfElement(tds[j], "A");
						if (atag && atag.innerHTML) {
							if (atag.innerHTML.indexOf("lij") >= 0)
								index_diffbyyesterday_percent = j;
							else if (atag.innerHTML.indexOf("l") >= 0)
								index_diffbyyesterday = j;
						}
					}
				}
				if ((portforioTable = getSpecifiedParentOfElement(trhead, new Array("TBODY", "TABLE"))) != null)
				break;
			}
		}
	}
	if (portforioTable == null || index_name < 0) {
		if (body.indexOf("̃|[gtHIɖǉɂ́uǉo^vĉB") >= 0)
			return true;
		return false;
	}

	var trs = portforioTable.getElementsByTagName("TR");
	if (!trs)
		return false;

	for (i = 1; i < trs.length; ++i) {
		tds = trs[i].getElementsByTagName("TD");
		if (tds.length > index_name) {
			var o = createEtradeStockObjectFromLink(getSpecifiedChildOfElement(tds[index_name], "A"));
			if (!o)
				continue;

			if (index_currentrate >= 0 && tds.length >= index_currentrate)
				o.currentrate = getSpecifiedChildOfElement(tds[index_currentrate]);
			if (index_diffbyyesterday >= 0 && tds.length >= index_diffbyyesterday)
				o.diffbyyesterday = getSpecifiedChildOfElement(tds[index_diffbyyesterday]);
			if (index_diffbyyesterday_percent >= 0 && tds.length >= index_diffbyyesterday_percent)
				o.diffbyyesterday_percent = getSpecifiedChildOfElement(tds[index_diffbyyesterday_percent]);
			if (index_highestrate_today >= 0 && tds.length >= index_highestrate_today)
				o.highestrate_today = getSpecifiedChildOfElement(tds[index_highestrate_today]);
			if (index_lowestrate_today >= 0 && tds.length >= index_lowestrate_today)
				o.lowestrate_today = getSpecifiedChildOfElement(tds[index_lowestrate_today]);
			if (index_buyrate >= 0 && tds.length >= index_buyrate)
				o.buyrate = getSpecifiedChildOfElement(tds[index_buyrate]);
			if (index_sellrate >= 0 && tds.length >= index_sellrate)
				o.sellrate = getSpecifiedChildOfElement(tds[index_sellrate]);
			if (index_amount >= 0 && tds.length >= index_amount)
				o.amount = getSpecifiedChildOfElement(tds[index_amount]);
			if (index_cost >= 0 && tds.length >= index_cost)
				o.cost = getSpecifiedChildOfElement(tds[index_cost]);
			if (index_profit >= 0 && tds.length >= index_profit)
				o.profit = getSpecifiedChildOfElement(tds[index_profit]);
			if (index_profit_percent >= 0 && tds.length >= index_profit_percent)
				o.profit_percent = getSpecifiedChildOfElement(tds[index_profit_percent]);

			target.data = mergeEtrdObject(target.data, o, null);
		}
	}

	return true;
}

function parseOrdering(target, body)
{
	if (!parseOrderingImpl(target, body)) {
		var estr = isEtradeError(body);
		if (!estr)
			return false;
		target.nonfatalerrors = target.nonfatalerrors + ((target.nonfatalerrors.length > 0) ? ", " : "") + estr;
	}

	/*
	var accountinfo_url = target.baseurl + accountinfo_url_param;
	if (debug)
		accountinfo_url = "ETGate_accounteasy.html";

	getAndParseHtml(function (body) { parseEtradeHtml(parseAccountinfo, target, body); }, accountinfo_url, "GET", null, target.sessionheader);
	*/

	parsePortforioAndNextChain(target, null);

	return true;
}

function parseOrderingImpl(target, body)
{
	var e = getSubstringByDivNodeFromHtml(body, "\x3c!-- ʌŗL --\x3e", "\x3c!-- ʌŗL --\x3e");
	if (e == null)
		return false;

	var tds;
	var i;

	var orderTable = null;
	for (tds = e.getElementsByTagName("TD"), i = 0; orderTable == null && tds && i < tds.length; ++i) {
		if (getSpecifiedChildOfElement(tds[i]) == "") {
			if ((orderTable = getSpecifiedParentOfElement(tds[i], new Array("TBODY", "TABLE"))) != null)
				break;
		}
	}
	if (orderTable == null) {
		if (body.indexOf("݁Aql̊蒍͂܂B") == -1)
			return false;
	}
	else {
		var trs = orderTable.getElementsByTagName("TR");
		if (!trs)
			return false;

		for (i = 4; i < trs.length; ++i) {
			tds = trs[i].getElementsByTagName("TD");
			if (tds.length != 5)
				continue;
			var onerows = tds[0].getAttribute("rowspan");
			if (onerows == null || isNaN(onerows = parseInt(onerows)))
				onerows = 1;
			var o = createEtradeStockObjectFromLink(getSpecifiedChildOfElement(tds[2], "A"));
			var orderid = getSpecifiedChildOfElement(tds[0]);
			if (o && orderid) { 
				var orderobj = new etrdOrderObject(orderid);
				var exchas = tds[3].getElementsByTagName("A");
				if (exchas.length == 2) {
					orderobj.modifylink = exchas[1].search;
					orderobj.deletelink = exchas[0].search;
				}
				if (onerows > 1 && (i + 1) < trs.length) {
					tds = trs[i + 1].getElementsByTagName("TD");
					if (tds.length == 4) {
						var exchdirection = getSpecifiedChildOfElement(tds[0]);
						if (tds[0].innerHTML.indexOf("") >= 0)
							orderobj.type = 1;
						else if (tds[0].innerHTML.indexOf("") >= 0)
							orderobj.type = -1;
						if (tds[2].childNodes.length >= 2)
							orderobj.amount = trimNumberString(tds[2].childNodes[2].nodeValue);
						if (tds[3].childNodes.length >= 2) {
							orderobj.rate = trimString(tds[3].childNodes[0].nodeValue);
							o.currentrate = trimNumberString(tds[3].childNodes[2].nodeValue);
						}
					}
				}
				if (onerows > 2 && (i + 2) < trs.length) {
					tds = trs[i + 2].getElementsByTagName("TD");
					if (tds.length == 1)
						orderobj.extstring = trimString(getSpecifiedChildOfElement(tds[0]));
				}

				target.data = mergeEtrdObject(target.data, o, orderobj);
			}

			i = i + (onerows - 1);
		}
	}

	/*
	if (target.finishFunc)
		target.finishFunc(target.data, target, 0);
	*/

	return true;
}

function parseAccountinfo(target, body)
{
	var e;
	var divs;
	var ptd;

	var i;

	target.accountinfo_left = null;
	if ((e = getSubstringByDivNodeFromHtml(body, "\x3c!--tEo/U֗]--\x3e", "\x3c!--tEo/U֗]--\x3e")) != null) {
		divs = e.getElementsByTagName("DIV");
		if (divs) {
			for (i = 0; i < divs.length; ++i) {
				if (getSpecifiedChildOfElement(divs[i]) == "t](3cƓ)") {
					if ((ptd = getSpecifiedParentOfElement(divs[i], "TD")) != null) {
						for (ptd = ptd.nextSibling; ptd; ptd = ptd.nextSibling) {
							if (ptd.nodeName == "TD") {
								if (ptd.firstChild && ptd.firstChild.firstChild)
									target.accountinfo_left = ptd.firstChild.firstChild.nodeValue;
								break;
							}
						}
					}
					break;
				}
			}
		}
	}

	target.accountinfo_total = null;
	if ((e = getSubstringByDivNodeFromHtml(body, "\x3c!--ۗLY]--\x3e", "\x3c!--ۗLY]--\x3e")) != null) {
		divs = e.getElementsByTagName("DIV");
		if (divs) {
			for (i = 0; i < divs.length; ++i) {
				if (getSpecifiedChildOfElement(divs[i]) == "v") {
					if ((ptd = getSpecifiedParentOfElement(divs[i], "TD")) != null) {
						for (ptd = ptd.nextSibling; ptd; ptd = ptd.nextSibling) {
							if (ptd.nodeName == "TD") {
								if (ptd.firstChild && ptd.firstChild.firstChild && ptd.firstChild.firstChild.firstChild)
									target.accountinfo_total = ptd.firstChild.firstChild.firstChild.nodeValue;
								break;
							}
						}
					}
					break;
				}
			}
		}
	}

	if (target.finishFunc)
		target.finishFunc(target.data, target, 0);

	return true;
}

/*
function parsePriceboard(target, body)
{
	var e = getSubstringByDivNodeFromHtml(body, "<form name=\"FORM\" method=\"POST\" action=\"/ETGate/\">", "</body>");
	if (e == null)
		return false;

	var tds;
	var i;
	var l = 0;

	for (tds = e.getElementsByTagName("TD"), i = 0; l != 0x1F && i < tds.length; ++i) {
		var dive;
		if (!(l & 0x01) && getSpecifiedChildOfElement(tds[i]) == "ݒl") {
			if (tds[i].nextSibling) {
				dive = tds[i].nextSibling.getElementsByTagName("DIV");
				if (dive && dive.length == 1) {
					if (dive[0].firstChild && dive[0].firstChild.firstChild && dive[0].firstChild.firstChild.firstChild)
						target.data.currentrate = dive[0].firstChild.firstChild.firstChild.nodeValue;
				}
			}
			l = l | 0x01;
		}
		else if (!(l & 0x02) && getSpecifiedChildOfElement(tds[i]) == "O") {
			if (tds[i].nextSibling) {
				dive = tds[i].nextSibling.getElementsByTagName("DIV");
				if (dive && dive.length == 1) {
					if (dive[0].firstChild && dive[0].firstChild.firstChild)
						target.data.diffbyyesterday = dive[0].firstChild.firstChild.nodeValue;
					if (dive[0].childNodes && dive[0].childNodes.length > 2 && dive[0].childNodes[2].firstChild && dive[0].childNodes[2].firstChild.nodeValue)
						target.data.diffbyyesterday_percent = dive[0].childNodes[2].firstChild.nodeValue;
				}
			}
			l = l | 0x02;
		}
		else if (!(l & 0x04) && getSpecifiedChildOfElement(tds[i]) == "l") {
			if (tds[i].nextSibling) {
				target.data.highestrate_today = trimString(getSpecifiedChildOfElement(tds[i].nextSibling));
			}
			l = l | 0x04;
		}
		else if (!(l & 0x08) && getSpecifiedChildOfElement(tds[i]) == "l") {
			if (tds[i].nextSibling) {
				target.data.lowestrate_today = trimString(getSpecifiedChildOfElement(tds[i].nextSibling));
			}
			l = l | 0x08;
		}
		else if (!(l & 0x10) && getSpecifiedChildOfElement(tds[i]) == "Czl") {
			var tbl = getSpecifiedParentOfElement(tds[i], "TABLE");
			if (tbl) {
				while ((tbl = tbl.nextSibling)) {
					if (tbl.nodeName == "TABLE")
						break;
				}
				if (tbl) {
					var trs = tbl.getElementsByTagName("TR");
					if (trs) {
						var j;
						for (j = 0; j < trs.length; ++j) {
							var ktds = trs[j].getElementsByTagName("TD");
							if (!ktds || ktds.length != 5)
								continue;
							var kv = ktds[2].firstChild;
							if (!kv)
								continue;
							if (kv.nodeValue == "s")
								continue;
							if (kv.nodeName == "FONT") {
								if (kv.getAttribute("color") == "#0000ff")
									target.data.sellrate = trimString(getSpecifiedChildOfElement(kv));
								else if (kv.getAttribute("color") == "#ff0000")
									target.data.buyrate = trimString(getSpecifiedChildOfElement(kv));
							}
						}
					}
				}
			}
			l = l | 0x10;
		}

	}

	if (target.finishFunc)
		target.finishFunc(target.data, target, 0);

	return true;
}
*/


function getfunc(baseurl, indicateid, targetports, callback, sessionheader)
{
	var target = new Object();

	target.baseurl = baseurl;
	target.sessionheader = sessionheader;
	target.data = null;
	target.portforios = null;
	target.indicates = null;
	target.nonfatalerrors = "";
	target.finishFunc = callback;
	target.portforio_indicate = indicateid;
	target.targetportforios = targetports;

	var portforio_url = target.baseurl + portforio_url_param + "&indicate_id=" + ((target.portforio_indicate) ? target.portforio_indicate : "000000000000001") + "&portforio_id=" + "000000000000001";
	if (debug)
		portforio_url = "ETGate_port.html";

	getAndParseHtml(function (body) { parseEtradeHtml(parsePortforioWithPortforioArray, target, body); }, portforio_url, "GET", null, target.sessionheader);
}
