/*
(C) 2007 Katsutoshi YAGISHITA (yagisita@spnet.ne.jp)
*/

function etrdOrderObject(id)
{
	this.id = null;
	this.type = 0;
	
	this.rate = "";
	this.amount = "";

	this.modifylink = null;
	this.deletelink = null;

	this.extstring = "";

	if (id)
		this.id = id;
}

etrdOrderObject.prototype.toString = function ()
{
	return this.id + "\n" + this.type + "\n" + this.rate + " * " + this.amount + '\n' + this.modifylink + "\n" + this.deletelink + "\n" + this.extstring;
};

function etrdStockObject(name, code, market, link)
{
	this.name = null;
	this.code = null;
	this.market = null;

	this.link = null;

	this.currentrate = "";
	this.diffbyyesterday = "";
	this.diffbyyesterday_percent = "";
	this.highestrate_today = "";
	this.lowestrate_today = "";
	this.buyrate = "";
	this.sellrate = "";

	this.amount = "";
	this.cost = "";
	this.profit = "";
	this.profit_percent = "";

	this.ordering = null;

	if (name)
		this.name = name;
	if (code)
		this.code = code;
	if (market)
		this.market = market;
	if (link)
		this.link = link;
}

etrdStockObject.prototype.merge = function (src)
{
	this.mergeeasy(src);

	if (src.cost && src.cost.length > 0)
		this.cost = src.cost;
	if (src.amount && src.amount.length > 0)
		this.amount = src.amount;
	if (src.profit && src.profit.length > 0)
		this.profit = src.profit;
	if (src.profit_percent && src.profit_percent.length > 0)
		this.profit_percent = src.profit_percent;
}

etrdStockObject.prototype.mergeeasy = function (src)
{
	if (src.currentrate && src.currentrate.length > 0) {
		if (!this.currentrate || !this.ordering)
			this.currentrate = src.currentrate;
	}
	if (src.diffbyyesterday && src.diffbyyesterday.length > 0)
		this.diffbyyesterday = src.diffbyyesterday;
	if (src.diffbyyesterday_percent && src.diffbyyesterday_percent.length > 0)
		this.diffbyyesterday_percent = src.diffbyyesterday_percent;
	if (src.highestrate_today && src.highestrate_today.length > 0)
		this.highestrate_today = src.highestrate_today;
	if (src.lowestrate_today && src.lowestrate_today.length > 0)
		this.lowestrate_today = src.lowestrate_today;
	if (src.buyrate && src.buyrate.length > 0)
		this.buyrate = src.buyrate;
	if (src.sellrate && src.sellrate.length > 0)
		this.sellrate = src.sellrate;
	if (src.sellrate && src.sellrate.length > 0)
		this.sellrate = src.sellrate;
}

etrdStockObject.prototype.toString = function ()
{
	return this.name + "(" + this.code + "/" + this.market + ")\n" + this.currentrate + "\n" + this.link + "\n" + this.diffbyyesterday + "(" + this.diffbyyesterday_percent + ")\n" + this.highestrate_today + ":" + this.lowestrate_today + "\n" + this.sellrate + ":" + this.buyrate + "\n" + this.cost + " * " + this.amount + '\n' + this.profit + "(" + this.profit_percent + ")\n" + this.ordering;
};

function etrdPortforioObject(id, name)
{
	this.id = id;
	this.name = name;
}

etrdPortforioObject.prototype.toString = function ()
{
	return this.id + ":" + this.name;
};


function createEtradeStockObjectFromLink(alink)
{
	if (!alink)
		return null;

	var name;
	if ((name = getSpecifiedChildOfElement(alink)) == null)
		return null;
	if (!alink.search)
		return null;

	var code, market;
	if ((code = getParameterFromSearchString(alink.search, "stock_sec_code_mul")) == null || (market = getParameterFromSearchString(alink.search, "exchange_code")) == null)
		return null;
	if (code.length > 4)
		code = code.substring(0, 4);

	return new etrdStockObject(name, code, market, alink.search);
}

function mergeEtrdObject(o, stockobj, orderobj)
{
	if (!stockobj)
		return;

	if (!o)
		o = new Array();

	var i;
	for (i = 0; i < o.length; ++i) {
		if (o[i].code == stockobj.code) {
			if (!o[i].amount || o[i].amount.length == 0 || o[i].amount.indexOf("--") >= 0) {
				o[i].merge(stockobj);
				break;
			}
			else if (!stockobj.amount || stockobj.amount.length == 0 || stockobj.amount.indexOf("--") >= 0) {
				o[i].mergeeasy(stockobj);
				break;
			}
			else
				o[i].mergeeasy(stockobj);
		}
	}
	if (i >= o.length)
		o[i] = stockobj;

	if (orderobj) {
		if (o[i].ordering == null)
			o[i].ordering = new Array();
		var j;
		for (j = 0; j < o[i].ordering.length; ++j) {
			if (o[i].ordering[j].id == orderobj.id) {
				o[i].ordering[j] = orderobj;
				break;
			}
		}
		if (j >= o[i].ordering.length)
			o[i].ordering[j] = orderobj;
	}

	return o;
}
